# Generated by the protocol buffer compiler.  DO NOT EDIT!
# Source: smarthttp.proto for package 'gitaly'

require 'grpc'
require 'smarthttp_pb'

module Gitaly
  module SmartHTTPService
    # SmartHTTPService is a service that provides RPCs required for HTTP-based Git
    # clones via the smart HTTP protocol.
    class Service

      include ::GRPC::GenericService

      self.marshal_class_method = :encode
      self.unmarshal_class_method = :decode
      self.service_name = 'gitaly.SmartHTTPService'

      # InfoRefsUploadPack provides the response for GET /info/refs?service=git-upload-pack.
      # It is invoked when the client fetches packs from the server, meaning the server will
      # upload the packs to that client. The client doesn't upload new objects. This is used
      # to advertise the references available on the server to the client via
      # git-upload-pack(1)'s `--advertise-refs` option.
      rpc :InfoRefsUploadPack, ::Gitaly::InfoRefsRequest, stream(::Gitaly::InfoRefsResponse)
      # InfoRefsReceivePack provides the response for GET /info/refs?service=git-receive-pack.
      # It is invoked when the client pushes packs to the server, meaning the server
      # will fetch the packs from the client. This is used to advertise the references
      # available on the server to the client via git-receive-pack(1)'s `--advertise-refs`
      # option.
      rpc :InfoRefsReceivePack, ::Gitaly::InfoRefsRequest, stream(::Gitaly::InfoRefsResponse)
      # PostUploadPackWithSidechannel provides the response for POST /upload-pack. It
      # used to transfer pack files from the server to the client via sidechannels. This
      # is invoked when the client executes `git fetch`.
      #
      # More info on sidechannels: https://gitlab.com/gitlab-org/gitaly/-/blob/master/doc/sidechannel.md
      rpc :PostUploadPackWithSidechannel, ::Gitaly::PostUploadPackWithSidechannelRequest, ::Gitaly::PostUploadPackWithSidechannelResponse
      # PostReceivePack provides the response for POST /receive-pack. It used to transfer
      # pack files from the client to the server. This is invoked when the client executes `git push`.
      rpc :PostReceivePack, stream(::Gitaly::PostReceivePackRequest), stream(::Gitaly::PostReceivePackResponse)
    end

    Stub = Service.rpc_stub_class
  end
end
